//
// Animations for Mandala
//

// Include files

#include <stdio.h>

#include "time.h"
#include "tlc5947.h"
#include "animations.h"

// Global variables

/* Values for each LED sets */
unsigned int groupes[NB_GROUPES];

/* Definition of LED sets */
int gu00[]={21,-1};
int gu01[]={20,-1};
int gu02[]={17,-1};
int gu03[]={15,-1};
int gu10[]={22,-1};
int gu11[]={19,-1};
int gu12[]={16,-1};
int gu13[]={14,-1};
int gu20[]={23,-1};
int gu21[]={18,-1};
int gu22[]={13,-1};
int gu30[]={12,-1};
int gu31[]={11,-1};
int gu40[]={0,-1};
int gu41[]={6,-1};
int gu42[]={10,-1};
int gu50[]={1,-1};
int gu51[]={4,-1};
int gu52[]={7,-1};
int gu53[]={9,-1};
int gu60[]={2,-1};
int gu61[]={3,-1};
int gu62[]={5,-1};
int gu63[]={8,-1};

int g00[]={21,20,17,15,-1};
int g01[]={22,19,16,14,-1};
int g02[]={23,18,13,-1};
int g03[]={12,11,-1};
int g04[]={0,6,10,-1};
int g05[]={1,4,7,9,-1};
int g06[]={2,3,5,8,-1};

/* Animations1 */
variation_params a1_von={.deltac=500,.deltad=0,.deltap=7250,.min=0,.max=600};
variation_params a1_voff={.deltac=0,.deltad=500,.deltap=7250,.min=0,.max=600};
variation_params a1_von2={.deltac=500,.deltad=0,.deltap=7250,.min=0,.max=400};
variation_params a1_voff2={.deltac=0,.deltad=500,.deltap=7250,.min=0,.max=400};
variation_params a1_vcycle={.deltac=250,.deltad=250,.deltap=7250,.min=0,.max=600};
animation a1[]={
  {0,31000,gu00,&a1_von,variation_groupes},
  {0,31000,gu60,&a1_von,variation_groupes},
  {250,31000,gu01,&a1_von,variation_groupes},
  {250,31000,gu61,&a1_von,variation_groupes},
  {500,31000,gu02,&a1_von,variation_groupes},
  {500,31000,gu62,&a1_von,variation_groupes},
  {750,31000,gu03,&a1_von,variation_groupes},
  {750,31000,gu63,&a1_von,variation_groupes},
  {1250,31000,gu00,&a1_voff,variation_groupes},
  {1250,31000,gu60,&a1_voff,variation_groupes},
  {1500,31000,gu01,&a1_voff,variation_groupes},
  {1500,31000,gu61,&a1_voff,variation_groupes},
  {1750,31000,gu02,&a1_voff,variation_groupes},
  {1750,31000,gu62,&a1_voff,variation_groupes},
  {2000,31000,gu03,&a1_voff,variation_groupes},
  {2000,31000,gu63,&a1_voff,variation_groupes},
  {2500,31000,gu10,&a1_von2,variation_groupes},
  {2500,31000,gu50,&a1_von2,variation_groupes},
  {2750,31000,gu11,&a1_von2,variation_groupes},
  {2750,31000,gu51,&a1_von2,variation_groupes},
  {3000,31000,gu12,&a1_von2,variation_groupes},
  {3000,31000,gu52,&a1_von2,variation_groupes},
  {3250,31000,gu13,&a1_von2,variation_groupes},
  {3250,31000,gu53,&a1_von2,variation_groupes},
  {3750,31000,gu10,&a1_voff2,variation_groupes},
  {3750,31000,gu50,&a1_voff2,variation_groupes},
  {4000,31000,gu11,&a1_voff2,variation_groupes},
  {4000,31000,gu51,&a1_voff2,variation_groupes},
  {4250,31000,gu12,&a1_voff2,variation_groupes},
  {4250,31000,gu52,&a1_voff2,variation_groupes},
  {4500,31000,gu13,&a1_voff2,variation_groupes},
  {4500,31000,gu53,&a1_voff2,variation_groupes},
  {5000,31000,gu20,&a1_von,variation_groupes},
  {5000,31000,gu40,&a1_von,variation_groupes},
  {5250,31000,gu21,&a1_von,variation_groupes},
  {5250,31000,gu41,&a1_von,variation_groupes},
  {5500,31000,gu22,&a1_von,variation_groupes},
  {5500,31000,gu42,&a1_von,variation_groupes},
  {6000,31000,gu20,&a1_voff,variation_groupes},
  {6000,31000,gu40,&a1_voff,variation_groupes},
  {6250,31000,gu21,&a1_voff,variation_groupes},
  {6250,31000,gu41,&a1_voff,variation_groupes},
  {6500,31000,gu22,&a1_voff,variation_groupes},
  {6500,31000,gu42,&a1_voff,variation_groupes},
  {7000,31000,gu30,&a1_vcycle,variation_groupes},
  {7250,31000,gu31,&a1_vcycle,variation_groupes},
  {7500,31000,gu30,&a1_vcycle,variation_groupes},
  {7750,31000,gu31,&a1_vcycle,variation_groupes},
  {-1,-1,NULL,NULL,NULL}
  };

/* Animation 2 */
variation_params a2_vcycle={.deltac=500,.deltad=500,.deltap=1000,.min=0,.max=600};
animation a2[]={
  {0,20000,g00,&a2_vcycle,variation_groupes},
  {0,20000,g06,&a2_vcycle,variation_groupes},
  {250,20000,g01,&a2_vcycle,variation_groupes},
  {250,20000,g05,&a2_vcycle,variation_groupes},
  {500,20000,g02,&a2_vcycle,variation_groupes},
  {500,20000,g04,&a2_vcycle,variation_groupes},
  {750,20000,g03,&a2_vcycle,variation_groupes}
  };

animation *anims[]={a1,a2,NULL};

/* Variables for animation settings */ 
int quantum=1000;
int stop;

// Functions
//

/* Wait some time */

void wait_us(unsigned long delay){
static unsigned long start;
if(delay==0) start=micros();
else
  while(1){
    unsigned long now=micros();
    unsigned long delta=now-start;
    if(delta>=delay) break;
    }
}

/* Get a set of LEDs size */

int taille_groupes(int leds[]){
int i=0;
while(leds[i]>=0) i++;
return i;
}

/* Set luminosity value to a set of LEDs */

void valeur_groupes(int leds[],unsigned int valeur){
int i=0;
while(1){ if(leds[i]<0) break; groupes[leds[i++]]=valeur; }
}

/* Compute variation of luminosity for a set of LEDs */

void variation_groupes(int leds[],void *arg,long temps,long at){
variation_params *p=arg;
long periode=p->deltac+p->deltad+p->deltap;	// Dans quelle phase de la variation se trouve-t-on ?
long instant=temps%periode;
if(instant<=p->deltac){				// Cas de la phase de croissance de p->min à p->max
  if(p->deltac>0){
    long calc=(long)p->max-(long)p->min;
    calc=calc*instant/p->deltac+p->min;
    valeur_groupes(leds,calc);
    }
  } 
else if(instant<=p->deltac+p->deltad){		// Cas de la phase de décroissance
  if(p->deltad>0){
    long calc=(long)p->min-(long)p->max;
    calc=calc*(instant-p->deltac)/p->deltad+p->max;
    valeur_groupes(leds,calc);
    }
  }
}

/* Variation set by set */

void variation_groupe(int leds[],void *arg,long temps,long at){
variation_params *p=arg;
long periode=p->deltac+p->deltad+p->deltap;
long nb=temps/periode;				// Quel groupe de LED est concerné ?
nb=nb%taille_groupes(leds);
int instant=temps%periode;			// Quelle est la phase courante de la variation ?
if(instant<=p->deltac){				// Cas de la phase de croissance de p->min à p->max
  long calc=(long)p->max-(long)p->min; calc=calc*instant/p->deltac+p->min;
  groupes[leds[nb]]=calc;
  }
else if(instant<=p->deltac+p->deltad){		// Cas de la phase de décroissance
  long calc=(long)p->min-(long)p->max; calc=calc*(instant-p->deltac)/p->deltad+p->max;
  groupes[leds[nb]]=calc;
  }
else 						// Cas de la pause
  groupes[leds[nb]]=p->min;
}

/* Play an animation */

void animation_play(animation *a){
static unsigned char init;
if(init==0){ init_LED_Drivers(NB_DRIVERS); init_time(); init=1; }
animation *p;
unsigned long temps=0;
int i;
for(i=0;i<NB_GROUPES;i++) groupes[i]=0;
while(stop==0){
  unsigned char actif=0;
  wait_us(0);
  for(p=a;p->depart>=0;p++){
    if(temps>p->arret) continue;
    actif=1;
    if(temps<p->depart) continue;
    p->fun_anim(p->groupes,p->params,temps-p->depart,temps);
    }
  if(!actif) break;
  set_LED_Drivers(groupes,NB_DRIVERS);
  wait_us(quantum);
  temps++;
  }
stop=0;
}

/* Play all animations */

void animation_all(void){
printf("Play all\n");
animation **a=anims;
while(*a!=NULL) animation_play(*a++);
}
