//
// Definitions to keep track of time
//

// Macros

#define clockCyclesPerMicrosecond() (F_CPU/1000000L)
#define clockCyclesToMicroseconds(a) (((a)*1000L)/(F_CPU/1000L))
#define MICROSECONDS_PER_TIMER0_OVERFLOW (clockCyclesToMicroseconds(64*256))
#define MILLIS_INC (MICROSECONDS_PER_TIMER0_OVERFLOW/1000)
// the fractional number of milliseconds per timer0 overflow. we shift right
// by three to fit these numbers into a byte. (for the clock speeds we care
// about - 8 and 16 MHz - this doesn't lose precision.)
#define FRACT_INC ((MICROSECONDS_PER_TIMER0_OVERFLOW%1000)>>3)
#define FRACT_MAX (1000>>3)

// Prototypes

void init_time(void);
unsigned long millis(void);
unsigned long micros(void);
